#!/usr/bin/env python
# Replace this URL with your city's URL, found at:
# http://weather.interceptvector.com/list.php

url = 'http://weather.interceptvector.com/weather.xml?id=VVNNTjAwMjc%3D'

# Should not need to change anything below

from xml.dom.minidom import parseString
from urllib import urlopen
from os.path import expanduser

home = expanduser('~')
try:
  xmlweather = urlopen(url).read()
  save = open(home + '/.kde/share/config/karamba_weather.xml', 'w')
  print >> save, xmlweather
except: # Maybe we're offline?
  try: # Try to load the saved weather data
    xmlweather = open(home + '/.kde/share/config/karamba_weather.xml', 'r').read()
  except:
    print "Error"
    from sys import exit
    exit()

dom = parseString(xmlweather)

def getText(nodelist):
  rc = ""
  for node in nodelist:
    if node.nodeType == node.TEXT_NODE:
      rc = rc + node.data
  return rc

def handleWeather(weather):
  w = []
  w += [getText((weather.getElementsByTagName("city")[0]).childNodes)]
  w += [getText((weather.getElementsByTagName("date")[0]).childNodes)[11:16]]

  scale = " " + getText((weather.getElementsByTagName("tempScale")[0]).childNodes)[:1]
 
  w += [getText((weather.getElementsByTagName("temp")[0]).childNodes) + scale]
  w += [getText((weather.getElementsByTagName("sky")[0]).childNodes)]
  w += ["large_icons/%s.png" % getText((weather.getElementsByTagName("wid")[0]).childNodes)]
  w += [getText((weather.getElementsByTagName("direction")[0]).childNodes)]
  w += [getText((weather.getElementsByTagName("strength")[0]).childNodes)]
  '''
  The rest of these I don't particularly care for, but you might, so they
  are included for future expansion, if you so desire.
  '''  
  w += [getText((weather.getElementsByTagName("barometer")[0]).childNodes)]
  w += [getText((weather.getElementsByTagName("humidity")[0]).childNodes)]
  w += [getText((weather.getElementsByTagName("realtemp")[0]).childNodes) + scale]
  w += [getText((weather.getElementsByTagName("uv")[0]).childNodes)]
  w += [getText((weather.getElementsByTagName("visibility")[0]).childNodes)]
  
  printlist(w)
  handleForecasts(weather.getElementsByTagName("forecast"), scale)

def handleForecasts(forecasts, scale):
  for forecast in forecasts:
    handleForecast(forecast, scale)

def handleForecast(forecast, scale):
  w = []
  w += [getText((forecast.getElementsByTagName("day")[0]).childNodes)[:3]]
  w += [getText((forecast.getElementsByTagName("high")[0]).childNodes) + "/" + \
        getText((forecast.getElementsByTagName("low")[0]).childNodes) + scale]
  w += ["small_icons/%s.png" % getText((forecast.getElementsByTagName("wid")[0]).childNodes)]
  w += [getText((forecast.getElementsByTagName("sky")[0]).childNodes)]
  w += ["%s%%" % getText((forecast.getElementsByTagName("precipitation")[0]).childNodes)]
  printlist(w)

def printlist(w):
  for item in w:
    print item

handleWeather(dom)
